#ifndef TANGO_BLOCKS_MERGE_HPP
#define TANGO_BLOCKS_MERGE_HPP

#include "tango/compile_phase.hpp"

namespace tango {

//----------------------------------------------------------------------------//

class BlocksMerge : public CompilePhase {
public:
  BlocksMerge(Ir* ir) : CompilePhase(ir, PhaseName::MRG) {}

protected:
  virtual void run_internal();

private:
  void          mergeConnector(Block* bc);
  void          mergeGoto(Block* pred, Block* bc, Block* succ);
  void          mergeCondBranch(Block* pred, Block* bc, Block* succ);
  void          mergeSwitch(Block* pred, Block* bc, Block* succ);
  void          mergeRethrow(Block* pred, Block* bc, Block* succ);
  void          mergeConnectors();
  void          mergeBlocks();
  void          find_empty_branches();
  void          delete_empty_branches(Block* b1);
  void          remove_succs(Block *b);
  bool          check_succ(Block* b);
  bool          block_has_only_branch_or_cmp(Block *b);
  bool          check_preds(Block *top);
private:
  Block*        not_empty_succ;
  BlockList     empty_blocks;
};

//----------------------------------------------------------------------------//

}      // namespace tango
#endif // TANGO_BLOCKS_MERGE_HPP
