#ifndef TANGO_BUNDLE_CUTTER_HPP
#define TANGO_BUNDLE_CUTTER_HPP

#include "tango/ir.hpp"
#include "tango/local_logger.hpp"

namespace tango {

//----------------------------------------------------------------------------//

typedef arena_map<Inst*, int>::type Colors;
typedef arena_map<int, Bundle*>::type SortedBundles;

//----------------------------------------------------------------------------//

class BundleCutter : public TangoObj {
public:
  BundleCutter(Ir* ir) : ir(ir) {}

  BundleList cutBundle(Bundle* bundle);
  BundleList cutBundle2(Bundle* bundle);
private:
  void unitColors(Colors& colors, int from, int to);
  void unitByDef(Inst* def_inst, InstList& insts);
  void unitByMemory(Inst* mem_inst, InstList& insts);

  BundleList generateBundlesByColors(Colors& colors, Inst* clf_inst);
  Ir*        ir;
  Colors     colors;
};

//----------------------------------------------------------------------------//

}       // namespace tango
#endif  // TANGO BUNDLE CUTTER HPP
