#ifndef TANGO_BUNDLE_HELPER_HPP
#define TANGO_BUNDLE_HELPER_HPP

#include "tango/ir.hpp"

namespace tango {

//----------------------------------------------------------------------------//

// This class contains common methods for suberblock and modulo scheduling

class BundlerHelper : public TangoObj {
public:
  BundlerHelper(Ir* ir) : ir(ir) {}
  
  void                setNop(Block*, int32_t);
  void                setNop(Bundle*, int32_t);
  void                updateNop(Bundle*, int32_t); // either creates nop or updates current to maximum
  bool                addNop(Bundle*, int32_t);
  int32_t             buildBypassMask(Inst*, int32_t) const;
  void                setAlsForDefs(Inst*);
  Opnd*               toSrc1(Opnd* op, InstList& insts) {
    if (!op->isImm()) return op;
    ImmOpnd* imm = op->asImm();
    uint64_t val = imm->getInt();
    bool is_negative = false;
    if(imm->isSigned()) {
      int64_t imm_s = static_cast<int64_t>(val);
      is_negative = (imm_s < 0);
    }
    
    if (is_negative || (val >> 5)/* || (op->reloc != NULL && op->reloc->asOopReloc() != NULL)*/)  {
      tango::Opnd* reg = ir->newRegOpnd(tango::REG_TYPE_R, op->data_type);
      insts.push_back(ir->newInst(tango::INST_MOV)->addUse(ir->px)->addUse(op)->addDef(reg));
      reg->flags = op->flags;
      return reg;
    } else {
      return op;
    }
  }
private:
  Ir*                 ir;
};

//----------------------------------------------------------------------------//

}      // namespace tango
#endif // TANGO BUNDLE HELPER HPP
