#ifndef TANGO_COALESCER_HPP
#define TANGO_COALESCER_HPP

#include "tango/compile_phase.hpp"

namespace tango {

typedef arena_map <Opnd*, Opnd*>::type Opnd2OpndMap;

//----------------------------------------------------------------------------//

class Coalescer : public CompilePhase {
public:
  Coalescer(Ir* ir) : CompilePhase(ir, PhaseName::CLS) {}
  void         coalesceUses(Inst*);
  void         coalesceDefs(Inst*);
  void         updateMoves(Inst*);

protected:
  virtual void run_internal();

public:
  Opnd2OpndMap moves;
};

//----------------------------------------------------------------------------//

}      // namespace tango
#endif // TANGO_COALESCER_HPP
