#ifndef TANGO_CODE_LAYOUTER_HPP
#define TANGO_CODE_LAYOUTER_HPP

#include "tango/compilation_session.hpp"

namespace tango {

//----------------------------------------------------------------------------//

class CodeLayouter {
public:
  CodeLayouter(Ir* ir) : _ir(ir), _name(PhaseName::CLA)  {}

  template<bool SORT_BLOCKS = true>
  void        run();

  Block*      getNextHead(BlockList&, Block*);
  Block*      getLayout(Block*);              // finds layout succ for this block
  Block*      getGotoLayout(Block*);
  Block*      getCondLayout(Block*, Inst*);
  Block*      getUnlockLayout(Block*);
  Block*      getSwitchLayout(Block*, Inst*);
  Block*      getReturnLayout();

  Inst*       removeBranch(Block*);
  void        insertBranch(Block*);

  Block*      getTrg(Inst*, int32_t);
  void        createCondBranch(Block*, Block*);
  Block*      createCondBranch(Block*, Block*, Block*);
  void        createBranchInsts(Block* block, Block* trg, Opnd *pred, bool inverse = false);

private:
  arena_vector<uint32_t>::type cur_reg;

  Ir*                          _ir;
  PhaseName                    _name;
};

//----------------------------------------------------------------------------//

}      // namespace tango
#endif // TANGO_CODE_LAYOUTER_HPP
