#ifndef COLD_PATH_MERGE_HPP
#define COLD_PATH_MERGE_HPP

#include "tango/compile_phase.hpp"
#include "tango/clone_helper.hpp"
#include "tango/inst_latency.hpp"
#include "tango/inst_dependencies.hpp"
#include "tango/bundler_helper.hpp"

namespace tango {

class MergeInfo : public TangoObj {
 public:
  Block *block;
  Inst* ct_inst;
  RegOpnd* ct_pred;
  //MergeInfo() : block(NULL), ct_inst(NULL), ct_pred(NULL) {}
  //MergeInfo(Block *b, Inst* i, RegOpnd* p) : block(b), ct_inst(i), ct_pred(p) {}
};

typedef arena_vector      <MergeInfo*>::type MergeInfoList;
typedef arena_map         <Inst*, int>::type InstDistanceMap;
typedef arena_map         <Opnd*, Inst*>::type OpndDefInstMap;

class ColdPathMerge: public CompilePhase {
public:
  ColdPathMerge(Ir* ir) :
    CompilePhase(ir, PhaseName::CPM) { }

protected:
  virtual void        run_internal();

private:
  MergeInfo *canBeMerged(Block *block);
  bool isDefinedInBundle(Opnd* op, Bundle *bndl);
  Block *tryMergeColdPath(MergeInfo *base_info, Block *block_layout_tail,
                          BlockSet &blocks_merged);
  void tryMergeCmpBranch(Block *branch_block);
};

}      // namespace tango

#endif // COLD_PATH_MERGE_HPP

