#ifndef TANGO_COND_READ_REGS_HPP
#define TANGO_COND_READ_REGS_HPP

#include "tango/ir.hpp"
#include "tango/live_analyser.hpp"

namespace tango {

//----------------------------------------------------------------------------//

/**
 * Calculate Opnds, that can't be modified before clf instruction.
 */
class CondReadRegs : public LiveAnalyser {
public:
  CondReadRegs(Ir* ir) : LiveAnalyser(ir, PhaseName::CRR), next_clf(NULL) {}

  void run(BlockList&);
  void run(Block*);
  void initLiveSet(Block*, Block*);
  void processBlock(Block*, Block*);
  void setUses(Inst*);
  void setUses(Inst*, BitMap&, RegOpndVector&);
  void defGlobals(Inst *inst);

  LiveSet       cond_read_set;
  LiveSet       globals;
  Inst*         next_clf;
};

//----------------------------------------------------------------------------//

}      // namespace tango
#endif // TANGO_COND_READ_REGS_HPP
