#ifndef TANGO_DYNAMIC_CHECKS_GENERATOR_HPP
#define TANGO_DYNAMIC_CHECKS_GENERATOR_HPP

#include "tango/inst_dependencies.hpp"
#include "tango/compile_phase.hpp"
#include "tango/block_cloner.hpp"
#include "tango/cfg.hpp"

namespace tango {

//----------------------------------------------------------------------------//

class DynchecksGenerator : public CompilePhase {
public:
  DynchecksGenerator(Ir* ir) : CompilePhase(ir, PhaseName::DCG),
    clone_helper(ir), ddg_builder(ir) {}
protected:
  virtual void run_internal();

private:
  bool                checkBlockIsLoop(Loop*); // check that this block is 1-block inner loop
  void                buildLoopDeps(DepGraph&, Block*);

  void                generateDynamicCheck(Block*);
  void                generateDynamicCheckForMultiBlocksLoop(Loop *);
  void                genCheckBlock(Loop*, Loop*);
  void                DynCheckGenDriver(Loop *);
  
private:
  CloneHelper         clone_helper;
  DepGraphBuilder     ddg_builder;

  bool                _lan_ran;
};

//----------------------------------------------------------------------------//

}      // namespace tango
#endif // TANGO_DYNAMIC_CHECKS_GENERATOR_HPP
