#ifndef TANGO_INST_LATENCY_HPP
#define TANGO_INST_LATENCY_HPP

#include "tango/tango_inst.hpp"

namespace tango {

//----------------------------------------------------------------------------//

#define LATENCY_PREDS_COLUMNS 4
#define LATENCY_CT_COLUMNS 3

//----------------------------------------------------------------------------//

class InstLatency : public TangoObj {
public:
  static int8_t       getLatency(InstCode, InstCode, bool); // read after write latency (first arg is write)

private:
  static int8_t       getLatencyForRegisters(OutOpType, InOpType, bool);
  static int8_t       getLatencyForPredicates(InstCode, InstCode);
  static int8_t       getLatencyForCt(InstCode, InstCode);

  static int8_t       getLatencyRowForPredicates(InstCode);
  static int8_t       getLatencyColumnForPredicates(InstCode);
  static int8_t       getLatencyRowForCt(InstCode);
  static int8_t       getLatencyColumnForCt(InstCode);

  static const int8_t inst_latency_registers[][IOT_LAST];   // instructions latency
  static const int8_t inst_latency_predicates[][LATENCY_PREDS_COLUMNS];   // instructions latency
  static const int8_t inst_latency_predicates_p9_fix[][LATENCY_PREDS_COLUMNS];
  static const int8_t inst_latency_ct[][LATENCY_CT_COLUMNS];   // instructions latency
};

//----------------------------------------------------------------------------//

}      // namespace tango
#endif // TANGO INST LATENCY HPP
