#ifndef TANGO_LOG_HPP
#define TANGO_LOG_HPP

#include "tango/ir.hpp"
#include "tango/utilities/bitMaps.hpp"
#include "tango/inst_scheduler.hpp"

#ifdef TANGO_LOG_ENABLED

namespace tango {

namespace log {

//----------------------------------------------------------------------------//

void           printInstStatistic();

arena_string   logOpndSet(const RegOpndVector&, const BitMap&);
arena_string   logLiveSet(const Ir*, const LiveSet&);
arena_string   logReloc(const Reloc*);
arena_string   toString(const Inst*, bool = false);
arena_string   toString(const Opnd*);
arena_string   toString(const DepNode*);
arena_string   toString(const Bundle*, bool = false);
arena_string   toString(const BitMap&);
arena_string   toString(const LiveSet&);
arena_string   toString(DataType);
arena_string   toString(uint64_t, DataType);
arena_string   toString(int32_t);
arena_string   toString(uint32_t);
arena_string   toString(int64_t);
arena_string   toString(uint64_t);
arena_string   toString(double);

arena_string   logRegOpnd(const RegOpnd*);
arena_string   dotLayoutEdges(const Block*);
arena_string   dotDepNodeMap(const Inst2DepNodeMap&);
arena_string   dotBlock(const Block*, ConstBlockSet&);
arena_string   dotDepNode(const DepNode*);
arena_string   printHead();
arena_string   printTail();
arena_string   rankdirBT();
arena_string   rankdirTB();

arena_string   printPr(const Inst*);
arena_string   printBranchPred(const Inst*);
arena_string   printInst(const Inst*);
arena_string   printSetwd(const Inst*);
arena_string   printBap(const Inst*, bool = false);
arena_string   printAbn(const Inst*, bool = false);
arena_string   printMova(const Inst*);
arena_string   printLdaa(const Inst*, bool = false);
arena_string   printStaa(const Inst*, bool = false);
arena_string   printLd(const Inst*);
arena_string   printSt(const Inst*);
arena_string   printCall(const Inst*);

//----------------------------------------------------------------------------//
arena_string   printCtCond(const Inst*);

template<typename T>
arena_string asPointer(T i) {
  arena_stringstream oss;
  oss << "0x" << std::hex << reinterpret_cast<uintptr_t>(i);
  return oss.str();
}

//----------------------------------------------------------------------------//

} // namespace log
} // namespace tango

#endif // TANGO_LOG_ENABLED
#endif // TANGO LOG HPP
