#ifndef TANGO_LOOP_BUILD_HPP
#define TANGO_LOOP_BUILD_HPP

#include "tango/compile_phase.hpp"
#include "tango/cfg.hpp"

namespace tango {

//----------------------------------------------------------------------------//

typedef arena_list<Loop*>::type              LoopList;

class LoopBuild : public CompilePhase {
public:
    LoopBuild(Ir* ir) : CompilePhase(ir, PhaseName::LBL), l_tree(NULL) {}

    void   backEdgeProcess(Block* tail_b, Block* head_b);
    void   childLoopProcess(Loop *new_parent, Loop *old_parent, Block *b);
    void   topLoopProcess(Loop *new_parent, Block *b);
    void   flowEdgeProcess(Block *succ_b);
    void   loopsBuild();
    void   TransformWhileToForLoop(Loop *l, bool is_valid);
    void   PeelLoop(Loop *l);
    void   BackEdgeListCreate(Loop *l);
    bool   valid_for_peel(Loop *l, Block *cb);
    bool   LoopIsInner(Loop *givenL, Loop *l);
    Loop*  getTopChild(Block *b, Loop *l, Loop *old_parent);

protected:
    virtual void run_internal();

private:
    Loop*               l_tree;
    BlockList           bstack;
    bool               _lan_ran;
};

//----------------------------------------------------------------------------//

}      // namespace tango
#endif // TANGO_LOOP_BUILD_HPP
