#ifndef MACRO_INST_HPP
#define MACRO_INST_HPP

#include "tango/compile_phase.hpp"
#include "tango/clone_helper.hpp"
#include "tango/inst_latency.hpp"
#include "tango/inst_dependencies.hpp"
#include "tango/bundler_helper.hpp"

namespace tango {

template <PeepHoleMode PH_MODE>
class MacroInsts: public CompilePhase {
public:
  MacroInsts(Ir* ir) :
    CompilePhase(ir, PhaseName::MIS) { }

    static void doCombinedInsts(Ir* ir, Block* block);

protected:
  virtual void        run_internal();

private:
  void combineArith();
  void combineCmpIBranch();

};

}      // namespace tango

#endif // MACRO_INST_HPP

