#ifndef TANGO_PROLOG_GENERATOR_HPP
#define TANGO_PROLOG_GENERATOR_HPP

#include "tango/compile_phase.hpp"

namespace tango {

//---------------------------------------------------------------------------//

class PrologGenerator : public CompilePhase {
public:
  PrologGenerator(Ir* ir) : CompilePhase(ir, PhaseName::PGR) {}

protected:
  virtual void run_internal();

private:
  void      genRegWindow();
  void      patchSetwds();
  void      setIrWsz();
  void      finalizeCall(Inst* call);
  void      finalizeStackDependentInstructions();

  Bundle*   prolog;
};

}      // namespace tango
#endif // TANGO PROLOG GENERATOR HPP
