#ifndef TANGO_STATE_FLUSHER_HPP
#define TANGO_STATE_FLUSHER_HPP

#include "tango/live_analyser.hpp"

namespace tango {

//----------------------------------------------------------------------------//

class StateFlusher : public LiveAnalyser {
public:
  StateFlusher(Ir* ir) : LiveAnalyser(ir, PhaseName::SFR), 
    safepoints(ir->debug_info->safepointInfo) {}

  void iterate();
  DerivedRegsSet& derivedRegs()    { return safepoints.derived_regs(); }

private:
  SafepointInfo& safepoints;
};

//----------------------------------------------------------------------------//

}       // namespace tango
#endif  // TANGO STATE FLUSHER HPP
