/* This pass adds sxt before instruction with double precision for uses that
 * were defined by single precision instructions.
 * We need to do this for architectures which has no support of WD.dbl bit like E3S
*/

#ifndef TANGO_SXT_CORRECTOR_HPP
#define TANGO_SXT_CORRECTOR_HPP

#include "tango/compile_phase.hpp"

namespace tango {

//----------------------------------------------------------------------------//

class SXTCorrector : public CompilePhase {
public:
  SXTCorrector(Ir* ir) : CompilePhase(ir, PhaseName::SXT) {}
protected:
  virtual void run_internal();
private:
  bool         isSingle(Inst*) const; // checks if this inst is double precision
};

//----------------------------------------------------------------------------//

} // namespace tango

#endif // TANGO_SXT_CORRECTOR_HPP
