#ifndef TANGO_LOG_VERIFIER_HPP
#define TANGO_LOG_VERIFIER_HPP

namespace tango {

// Verifier for TangoLog string option, used in arguments.cpp
class TangoLogVerifier {
public:
	static bool verifyTangoLog(const char *);

private:
	static bool verifySymbols(const char*);
	static bool verifyFormat(const char*);
	static bool verifyToken(const char*);
	static bool verifyName(const char*, size_t, size_t);
	static bool verifyLevel(const char*, size_t, size_t);
	static bool isStringDelimiter(char);
	static bool isOptionDelimiter(char);

	static void reportError(const char*, const char*, size_t);

public:
	static const size_t _min_token_length = 3;
	static const size_t _max_token_length = 5;

	static const size_t _phase_names_size;
	static const size_t _log_levels_size;

	static const char*  _phase_names[];
	static const char*  _log_levels[];
	static const char*  _option_delimiters;
	static const char*  _string_delimiters;
};

}      // namespace tango
#endif // TANGO_LOG_VERIFIER_HPP
